/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.39 Revision 1.48
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.39 2006/10/20 14:44:01 chtekk Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.48 2006/12/10 18:32:03 vivo Exp $
4 4
5# Author: Francesco Riosa <vivo@gentoo.org> 5# Author: Francesco Riosa <vivo@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 6# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7 7
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too 8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
23 done 23 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH) 24 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi 26fi
27 27
28DEPEND="${DEPEND} 28inherit eutils flag-o-matic gnuconfig autotools mysql_fx
29
30# Be warned, *DEPEND are version-dependant
31DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps )
33 >=sys-apps/sed-4
34 >=sys-apps/texinfo-4.7-r1
29 >=sys-libs/readline-4.1 35 >=sys-libs/readline-4.1
30 berkdb? ( sys-apps/ed )
31 ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps )
33 >=sys-libs/zlib-1.2.3 36 >=sys-libs/zlib-1.2.3"
34 >=sys-apps/texinfo-4.7-r1 37
35 >=sys-apps/sed-4" 38# LEAVE THE SURROUNDING SPACES THERE
39MYSQL_MUTUALLY_EXCLUSIVE=" !dev-db/mysql !dev-db/mysql-community "
40DEPEND="${DEPEND} ${MYSQL_MUTUALLY_EXCLUSIVE/ !${CATEGORY}\/${PN} /}"
41
42mysql_version_is_at_least "5.01.00.00" \
43|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
36 44
37RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )" 45RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
38 46
39# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 47# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
40PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 48PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
41 49
42inherit eutils flag-o-matic gnuconfig autotools mysql_fx
43
44# Shorten the path because the socket path length must be shorter than 107 chars 50# Shorten the path because the socket path length must be shorter than 107 chars
45# and we will run a mysql server during test phase 51# and we will run a mysql server during test phase
46S="${WORKDIR}/${PN}" 52S="${WORKDIR}/mysql" # BitKeeper ebuilds
47 53
48# Define $MY_FIXED_PV for MySQL patchsets 54# Define $MY_FIXED_PV for MySQL patchsets
49MY_FIXED_PV="${PV/_alpha/}" 55MY_FIXED_PV="${PV/_alpha/}"
50#MY_FIXED_PV="${MY_FIXED_PV/_beta/}" 56#MY_FIXED_PV="${MY_FIXED_PV/_beta/}"
51#MY_FIXED_PV="${MY_FIXED_PV/_rc/}" 57#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
52 58
53MY_P="${P/_/-}" 59MY_P="${P/_/-}"
60MY_P="${MY_P/-alpha/-bk-}" # BitKeeper ebuilds
61MY_P="${MY_P/-community/}"
54 62
55# Define correct SRC_URIs 63# Define correct SRC_URIs
56SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${MY_P}${MYSQL_RERELEASE}.tar.gz" 64SRC_URI="${BASE_URI}/${MY_P}${MYSQL_RERELEASE}.tar.gz"
57if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then 65if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then
58 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2" 66 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2"
59 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball 67 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball
60 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}" 68 SRC_URI="${SRC_URI} http://g3nt8.org/patches/${MYSQL_PATCHSET_FILENAME}"
61fi 69fi
62 70
63DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 71DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
64HOMEPAGE="http://www.mysql.com/" 72HOMEPAGE="http://www.mysql.com/"
65SLOT="0" 73SLOT="0"
147 export MY_INCLUDEDIR 155 export MY_INCLUDEDIR
148 export DATADIR 156 export DATADIR
149} 157}
150 158
151configure_minimal() { 159configure_minimal() {
152 # These are things we exclude from a minimal build, please 160 # These are things we exclude from a minimal build, please
153 # note that the server actually does get built and installed, 161 # note that the server actually does get built and installed,
154 # but we then delete it before packaging. 162 # but we then delete it before packaging.
155 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 163 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
156 164
157 for i in ${minimal_exclude_list} ; do 165 for i in ${minimal_exclude_list} ; do
158 myconf="${myconf} --without-${i}" 166 myconf="${myconf} --without-${i}"
159 done 167 done
160 myconf="${myconf} --with-extra-charsets=none" 168 myconf="${myconf} --with-extra-charsets=none"
169 myconf="${myconf} --enable-local-infile"
170
171 if useq "static" ; then
172 myconf="${myconf} --with-client-ldflags=-all-static"
173 myconf="${myconf} --disable-shared"
174 else
175 myconf="${myconf} --enable-shared --enable-static"
176 fi
161} 177}
162 178
163configure_common() { 179configure_common() {
164 myconf="${myconf} $(use_with big-tables)" 180 myconf="${myconf} $(use_with big-tables)"
165 myconf="${myconf} --enable-local-infile" 181 myconf="${myconf} --enable-local-infile"
166 myconf="${myconf} --with-extra-charsets=all" 182 myconf="${myconf} --with-extra-charsets=all"
167 myconf="${myconf} --with-mysqld-user=mysql" 183 myconf="${myconf} --with-mysqld-user=mysql"
168 myconf="${myconf} --with-server" 184 myconf="${myconf} --with-server"
169 myconf="${myconf} --with-unix-socket-path='/var/run/mysqld/mysqld.sock'" 185 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
170 myconf="${myconf} --without-libwrap" 186 myconf="${myconf} --without-libwrap"
171 187
172 if useq "static" ; then 188 if useq "static" ; then
173 myconf="${myconf} --with-mysqld-ldflags=-all-static" 189 myconf="${myconf} --with-mysqld-ldflags=-all-static"
174 myconf="${myconf} --with-client-ldflags=-all-static" 190 myconf="${myconf} --with-client-ldflags=-all-static"
269 && useq "max-idx-128" \ 285 && useq "max-idx-128" \
270 && myconf="${myconf} --with-max-indexes=128" 286 && myconf="${myconf} --with-max-indexes=128"
271} 287}
272 288
273configure_51() { 289configure_51() {
274 # TODO : !!!!! readd --withouth-readline 290 # TODO: !!!! readd --without-readline
275 # the failure depend upon config/ac-macros/readline.m4 checking into 291 # the failure depend upon config/ac-macros/readline.m4 checking into
276 # readline.h instead of history.h 292 # readline.h instead of history.h
277 myconf="${myconf} $(use_with ssl)" 293 myconf="${myconf} $(use_with ssl)"
278 myconf="${myconf} --enable-assembler" 294 myconf="${myconf} --enable-assembler"
279 myconf="${myconf} --with-geometry" 295 myconf="${myconf} --with-geometry"
286 # 5.1 introduces a new way to manage storage engines (plugins) 302 # 5.1 introduces a new way to manage storage engines (plugins)
287 # like configuration=none 303 # like configuration=none
288 local plugins="csv,myisam,myisammrg,heap" 304 local plugins="csv,myisam,myisammrg,heap"
289 if useq "extraengine" ; then 305 if useq "extraengine" ; then
290 # like configuration=max-no-ndb, archive and example removed in 5.1.11 306 # like configuration=max-no-ndb, archive and example removed in 5.1.11
291 plugins="${plugins},blackhole,federated,ftexample,partition" 307 plugins="${plugins},archive,blackhole,example,federated,ftexample,partition"
292 308
293 elog "Before using the Federated storage engine, please be sure to read" 309 elog "Before using the Federated storage engine, please be sure to read"
294 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 310 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
295 fi 311 fi
296 312
339 && useq "minimal" ; then 355 && useq "minimal" ; then
340 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 356 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
341 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 357 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
342 fi 358 fi
343 359
360 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \
361 && useq "berkdb" \
344 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 362 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
345} 363}
346 364
347mysql_src_unpack() { 365mysql_src_unpack() {
348 # Initialize the proper variables first 366 # Initialize the proper variables first
349 mysql_init_vars 367 mysql_init_vars
383 rm -f "scripts/mysqlbug" 401 rm -f "scripts/mysqlbug"
384 fi 402 fi
385 403
386 local rebuilddirlist bdbdir d 404 local rebuilddirlist bdbdir d
387 405
388 if mysql_version_is_at_least "5.01.00.00" ; then 406 if mysql_version_is_at_least "5.01.12.00" ; then
389 rebuilddirlist=". storage/innobase" 407 # TODO: innodb is using cmake now?
390 bdbdir='storage/bdb/dist' 408 rebuilddirlist="."
409 bdbdir=''
391 else 410 else
392 rebuilddirlist=". innobase" 411 rebuilddirlist=". innobase"
393 bdbdir='bdb/dist' 412 bdbdir='bdb/dist'
394 fi 413 fi
395 414
398 pushd "${d}" &>/dev/null 417 pushd "${d}" &>/dev/null
399 AT_GNUCONF_UPDATE="yes" eautoreconf 418 AT_GNUCONF_UPDATE="yes" eautoreconf
400 popd &>/dev/null 419 popd &>/dev/null
401 done 420 done
402 421
403 # Berkeley DB has been removed in MySQL 5.1
404 if useq "berkdb" \
405 && mysql_check_version_range "4.01.00.00 to 5.00.99.99" ; then 422 if mysql_check_version_range "4.01.00.00 to 5.00.99.99" \
423 && useq "berkdb" ; then
406 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh" 424 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh"
407 pushd "${bdbdir}" \ 425 pushd "${bdbdir}" \
408 && sh s_all \ 426 && sh s_all \
409 || die "Failed bdb reconfigure" \ 427 || die "Failed bdb reconfigure" \
410 &>/dev/null 428 &>/dev/null
414 432
415mysql_src_compile() { 433mysql_src_compile() {
416 # Make sure the vars are correctly initialized 434 # Make sure the vars are correctly initialized
417 mysql_init_vars 435 mysql_init_vars
418 436
437 # $myconf is modified by the configure_* functions
419 local myconf 438 local myconf=""
420 439
421 if useq "static" ; then
422 myconf="${myconf} --with-mysqld-ldflags=-all-static"
423 myconf="${myconf} --with-client-ldflags=-all-static"
424 myconf="${myconf} --disable-shared"
425 else
426 myconf="${myconf} --enable-shared --enable-static"
427 fi
428
429 myconf="${myconf} --without-libwrap"
430
431 if useq "ssl" ; then 440 if useq "minimal" ; then
432 # --with-vio is not needed anymore, it's on by default and 441 configure_minimal
433 # has been removed from configure 442 else
434 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 443 configure_common
435 if mysql_version_is_at_least "5.00.06.00" ; then 444 if mysql_version_is_at_least "5.01.10.00" ; then
436 # yassl-0.96 is still young and breaks with GCC-4.X or amd64 445 configure_51
437 # myconf="${myconf} --with-yassl"
438 myconf="${myconf} --with-openssl"
439 else 446 else
440 myconf="${myconf} --with-openssl" 447 configure_40_41_50
441 fi
442 else
443 myconf="${myconf} --without-openssl"
444 fi
445
446 if useq "debug" ; then
447 myconf="${myconf} --with-debug=full"
448 else
449 myconf="${myconf} --without-debug"
450
451 mysql_version_is_at_least "4.01.03.00" && useq "cluster" \
452 && myconf="${myconf} --without-ndb-debug"
453 fi
454
455 # These are things we exclude from a minimal build.
456 # Note that the server actually does get built and installed,
457 # but we then delete it.
458 local minimal_exclude_list="server embedded-server extra-tools innodb bench"
459
460 if ! useq "minimal" ; then
461 myconf="${myconf} --with-server"
462 myconf="${myconf} --with-extra-tools"
463
464 if ! mysql_version_is_at_least "5.00.00.00" ; then
465 if useq "raid" ; then
466 myconf="${myconf} --with-raid"
467 else
468 myconf="${myconf} --without-raid"
469 fi 448 fi
470 fi
471
472 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
473 myconf="${myconf} --with-charset=utf8"
474 myconf="${myconf} --with-collation=utf8_general_ci"
475 else
476 myconf="${myconf} --with-charset=latin1"
477 myconf="${myconf} --with-collation=latin1_swedish_ci"
478 fi
479
480 # Optional again with MySQL 5.1
481 if mysql_version_is_at_least "5.01.00.00" ; then
482 if useq "innodb" ; then
483 myconf="${myconf} --with-innodb"
484 else
485 myconf="${myconf} --without-innodb"
486 fi
487 fi
488
489 # Lots of charsets
490 myconf="${myconf} --with-extra-charsets=all"
491
492 # The following fix is due to a bug with bdb on SPARC's. See:
493 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
494 # It comes down to non-64-bit safety problems.
495 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
496 elog "Berkeley DB support was disabled due to incompatible arch"
497 myconf="${myconf} --without-berkeley-db"
498 else
499 # TODO: berkdb in MySQL 5.1 needs to be worked on
500 if useq "berkdb" && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
501 myconf="${myconf} --with-berkeley-db=./bdb"
502 else
503 myconf="${myconf} --without-berkeley-db"
504 fi
505 fi
506
507 if mysql_version_is_at_least "4.01.03.00" ; then
508 myconf="${myconf} --with-geometry"
509
510 if useq "cluster" ; then
511 myconf="${myconf} --with-ndbcluster"
512 else
513 myconf="${myconf} --without-ndbcluster"
514 fi
515 fi
516
517 if useq "big-tables" ; then
518 myconf="${myconf} --with-big-tables"
519 else
520 myconf="${myconf} --without-big-tables"
521 fi
522
523 mysql_version_is_at_least "5.01.06.00" \
524 && myconf="${myconf} --with-ndb-binlog"
525
526 if useq "embedded" ; then
527 myconf="${myconf} --with-embedded-privilege-control"
528 myconf="${myconf} --with-embedded-server"
529 else
530 myconf="${myconf} --without-embedded-privilege-control"
531 myconf="${myconf} --without-embedded-server"
532 fi
533
534 # Benchmarking stuff needs Perl
535 if useq "perl" ; then
536 myconf="${myconf} --with-bench"
537 else
538 myconf="${myconf} --without-bench"
539 fi
540 else
541 for i in ${minimal_exclude_list} ; do
542 myconf="${myconf} --without-${i}"
543 done
544 myconf="${myconf} --without-berkeley-db"
545 myconf="${myconf} --with-extra-charsets=none"
546 fi
547
548 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
549 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
550 myconf="${myconf} --with-archive-storage-engine"
551
552 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
553 myconf="${myconf} --with-csv-storage-engine"
554
555 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
556 myconf="${myconf} --with-blackhole-storage-engine"
557
558 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
559 # http://dev.mysql.com/doc/mysql/en/federated-description.html
560 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
561 if mysql_version_is_at_least "5.00.03.00" ; then
562 elog "Before using the Federated storage engine, please be sure to read"
563 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
564 myconf="${myconf} --with-federated-storage-engine"
565 fi
566
567 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
568 if mysql_version_is_at_least "5.01.00.00" ; then
569 myconf="${myconf} --with-partition"
570 fi
571 fi
572
573 mysql_version_is_at_least "5.00.18.00" \
574 && useq "max-idx-128" \
575 && myconf="${myconf} --with-max-indexes=128"
576
577 mysql_version_is_at_least "5.01.05.00" \
578 && myconf="${myconf} --with-row-based-replication"
579
580 # TODO: Rechek again later, there were problems with assembler enabled
581 # and some combination of USE flags with MySQL 5.1
582 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
583 myconf="${myconf} --disable-assembler"
584 else
585 myconf="${myconf} --enable-assembler"
586 fi 449 fi
587 450
588 # Bug #114895, bug #110149 451 # Bug #114895, bug #110149
589 filter-flags "-O" "-O[01]" 452 filter-flags "-O" "-O[01]"
590 453
591 # glib-2.3.2_pre fix, bug #16496 454 # glib-2.3.2_pre fix, bug #16496
592 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 455 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
593 456
594 append-flags "-fno-exceptions -fno-strict-aliasing" 457 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
595 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 458 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
596 mysql_version_is_at_least "5.00.00.00" \ 459 mysql_version_is_at_least "5.00.00.00" \
597 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 460 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
598 export CXXFLAGS 461 export CXXFLAGS
599 462
603 --localstatedir="${MY_LOCALSTATEDIR}" \ 466 --localstatedir="${MY_LOCALSTATEDIR}" \
604 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 467 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
605 --libdir="${MY_LIBDIR}" \ 468 --libdir="${MY_LIBDIR}" \
606 --includedir="${MY_INCLUDEDIR}" \ 469 --includedir="${MY_INCLUDEDIR}" \
607 --with-low-memory \ 470 --with-low-memory \
608 --enable-local-infile \
609 --with-mysqld-user=mysql \
610 --with-client-ldflags=-lstdc++ \ 471 --with-client-ldflags=-lstdc++ \
611 --enable-thread-safe-client \ 472 --enable-thread-safe-client \
612 --with-comment="Gentoo Linux ${PF}" \ 473 --with-comment="Gentoo Linux ${PF}" \
613 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \
614 --without-readline \
615 --without-docs \ 474 --without-docs \
616 ${myconf} || die "econf failed" 475 ${myconf} || die "econf failed"
617 476
618 # TODO: Move this before autoreconf !!! 477 # TODO: Move this before autoreconf !!!
619 find . -type f -name Makefile -print0 \ 478 find . -type f -name Makefile -print0 \
749 elog "if this is a new install." 608 elog "if this is a new install."
750 einfo 609 einfo
751 mysql_version_is_at_least "5.01.00.00" \ 610 mysql_version_is_at_least "5.01.00.00" \
752 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream." 611 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream."
753 fi 612 fi
613 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \
614 && useq "berkdb" \
754 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 615 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
755} 616}
756 617
757mysql_pkg_config() { 618mysql_pkg_config() {
758 # Make sure the vars are correctly initialized 619 # Make sure the vars are correctly initialized
759 mysql_init_vars 620 mysql_init_vars

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.48

  ViewVC Help
Powered by ViewVC 1.1.20